"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var Platform = require('platform');
var absolute_layout_1 = require('ui/layouts/absolute-layout');
var stack_layout_1 = require('ui/layouts/stack-layout');
var view_1 = require('ui/core/view');
var button_1 = require('ui/button');
var utilities_1 = require('./utilities');
var Slide = (function (_super) {
    __extends(Slide, _super);
    function Slide() {
        _super.apply(this, arguments);
    }
    return Slide;
}(stack_layout_1.StackLayout));
exports.Slide = Slide;
var IntroSlides = (function (_super) {
    __extends(IntroSlides, _super);
    function IntroSlides() {
        var _this = this;
        _super.call(this);
        this._addChildFromBuilder = function (name, value) {
            if (value instanceof view_1.View) {
                if (value instanceof Slide) {
                    _this._childSlides.push(value);
                }
                _this.addChild(value);
            }
        };
        this.constructView();
    }
    Object.defineProperty(IntroSlides.prototype, "android", {
        get: function () {
            return;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IntroSlides.prototype, "ios", {
        get: function () {
            return;
        },
        enumerable: true,
        configurable: true
    });
    IntroSlides.prototype.constructView = function () {
        var _this = this;
        this._loaded = false;
        this._childSlides = [];
        var pageWidth = Platform.screen.mainScreen.widthDIPs;
        var pageHeight = Platform.screen.mainScreen.heightDIPs;
        this.on(absolute_layout_1.AbsoluteLayout.loadedEvent, function (data) {
            if (!_this._loaded) {
                _this._loaded = true;
                var footer = _this.buildFooter();
                _this.addChild(footer);
                var btnPrevious = footer.getViewById('btn-info-previous');
                var btnNext = footer.getViewById('btn-info-next');
                var slides_1 = [];
                _this.eachLayoutChild(function (view) {
                    if (view instanceof stack_layout_1.StackLayout) {
                        if (slides_1.length !== 0) {
                            absolute_layout_1.AbsoluteLayout.setLeft(view, pageWidth);
                        }
                        view.width = pageWidth;
                        view.height = '100%';
                        slides_1.push(view);
                    }
                });
                var panelMap1 = utilities_1.SlideUtilities.buildSlideMap(slides_1);
                panelMap1.panel.width = pageWidth;
                if (isNaN(footer.height)) {
                    footer.height = 76;
                }
                absolute_layout_1.AbsoluteLayout.setTop(footer, (pageHeight - footer.height));
                utilities_1.SlideUtilities.applySwipe(_this, pageWidth, panelMap1, btnPrevious, btnNext);
            }
        });
    };
    IntroSlides.prototype.buildFooter = function () {
        var footer = new absolute_layout_1.AbsoluteLayout();
        var footerInnerWrap = new stack_layout_1.StackLayout();
        var footerInnerWrapLeft = new stack_layout_1.StackLayout();
        var footerInnerWrapMiddle = new stack_layout_1.StackLayout();
        var footerInnerWrapRight = new stack_layout_1.StackLayout();
        this.setwidthPercent(footer, 100);
        footerInnerWrap.orientation = 'horizontal';
        this.setwidthPercent(footerInnerWrap, 100);
        footer.addChild(footerInnerWrap);
        this.setwidthPercent(footerInnerWrapRight, 30);
        this.setwidthPercent(footerInnerWrapLeft, 30);
        this.setwidthPercent(footerInnerWrapMiddle, 40);
        footerInnerWrapLeft.addChild(this.newButtoner('Previous'));
        footerInnerWrapRight.addChild(this.newButtoner('Next'));
        footerInnerWrap.addChild(footerInnerWrapLeft);
        footerInnerWrap.addChild(footerInnerWrapMiddle);
        footerInnerWrap.addChild(footerInnerWrapRight);
        return footer;
    };
    IntroSlides.prototype.setwidthPercent = function (view, percentage) {
        view.width = percentage + '%';
    };
    IntroSlides.prototype.newButtoner = function (name) {
        var button = new button_1.Button();
        button.id = 'btn-info-' + name.toLowerCase();
        button.text = name;
        this.setwidthPercent(button, 100);
        return button;
    };
    return IntroSlides;
}(absolute_layout_1.AbsoluteLayout));
exports.IntroSlides = IntroSlides;
//# sourceMappingURL=nativescript-intro-slides.js.map