"use strict";
var gestures = require('ui/gestures');
var absolute_layout_1 = require('ui/layouts/absolute-layout');
var SlideUtilities = (function () {
    function SlideUtilities() {
    }
    SlideUtilities.buildSlideMap = function (views) {
        var slideMap = [];
        views.forEach(function (view) {
            slideMap.push({
                panel: view
            });
        });
        slideMap.forEach(function (mapping, index) {
            mapping.left = slideMap[index - 1];
            mapping.right = slideMap[index + 1];
        });
        return slideMap[0];
    };
    SlideUtilities.applySwipe = function (wrapper, pageWidth, panelMap, btnPrevious, btnNext) {
        var _this = this;
        var previousDelta = -1;
        btnPrevious.visibility = 'collapse';
        btnNext.visibility = 'collapse';
        if (panelMap.left != null) {
            btnPrevious.visibility = 'visible';
        }
        if (panelMap.right != null) {
            btnNext.visibility = 'visible';
        }
        btnNext.off('tap');
        btnPrevious.off('tap');
        btnNext.on('tap', function () {
            _this.showRightSlide(panelMap, wrapper, pageWidth, btnPrevious, btnNext);
            panelMap.right.panel.width = pageWidth - panelMap.panel.width;
            absolute_layout_1.AbsoluteLayout.setLeft(panelMap.right.panel, panelMap.panel.width);
        });
        btnPrevious.on('tap', function () {
            _this.showLeftSlide(panelMap, wrapper, pageWidth, btnPrevious, btnNext);
        });
        panelMap.panel.on('touch, pan', function (args) {
            if (args.action === gestures.TouchAction.up) {
                if (_this.direction === 'left' && panelMap.right != null && panelMap.panel.width > ((pageWidth / 3) * 2)) {
                    panelMap.right.panel.width = 0;
                    panelMap.panel.width = pageWidth;
                    absolute_layout_1.AbsoluteLayout.setLeft(panelMap.panel, 0);
                    absolute_layout_1.AbsoluteLayout.setLeft(panelMap.right.panel, pageWidth);
                    _this.direction = null;
                    return;
                }
                if (_this.direction === 'right' && panelMap.panel.width > (pageWidth / 2)) {
                    if (panelMap.left != null) {
                        panelMap.left.panel.width = 0;
                    }
                    panelMap.panel.width = pageWidth;
                    absolute_layout_1.AbsoluteLayout.setLeft(panelMap.panel, 0);
                    _this.direction = null;
                    return;
                }
            }
            if (args.eventName = 'pan') {
                if (panelMap.right != null && previousDelta !== args.deltaX) {
                    if (args.deltaX < -5) {
                        _this.direction = 'left';
                        panelMap.panel.width = pageWidth + args.deltaX;
                        if (panelMap.panel.width < ((pageWidth / 3) * 2)) {
                            _this.showRightSlide(panelMap, wrapper, pageWidth, btnPrevious, btnNext);
                        }
                        panelMap.right.panel.width = pageWidth - panelMap.panel.width;
                        absolute_layout_1.AbsoluteLayout.setLeft(panelMap.right.panel, panelMap.panel.width);
                    }
                }
                if (panelMap.left != null && previousDelta !== args.deltaX) {
                    if (args.deltaX > 5) {
                        _this.direction = 'right';
                        absolute_layout_1.AbsoluteLayout.setLeft(panelMap.panel, args.deltaX);
                        panelMap.left.panel.width = args.deltaX;
                        if (args.deltaX > (pageWidth / 4)) {
                            _this.showLeftSlide(panelMap, wrapper, pageWidth, btnPrevious, btnNext);
                        }
                    }
                }
                if (args.deltaX !== 0)
                    previousDelta = args.deltaX;
            }
        });
    };
    SlideUtilities.showRightSlide = function (panelMap, wrapper, pageWidth, btnPrevious, btnNext) {
        panelMap.panel.width = 0;
        panelMap.panel.off('pan, touch');
        this.applySwipe(wrapper, pageWidth, panelMap.right, btnPrevious, btnNext);
        panelMap.right.panel.width = pageWidth;
        this.direction = null;
    };
    SlideUtilities.showLeftSlide = function (panelMap, wrapper, pageWidth, btnPrevious, btnNext) {
        panelMap.left.panel.width = pageWidth;
        absolute_layout_1.AbsoluteLayout.setLeft(panelMap.left.panel, 0);
        absolute_layout_1.AbsoluteLayout.setLeft(panelMap.panel, pageWidth);
        panelMap.panel.off('pan, touch');
        this.applySwipe(wrapper, pageWidth, panelMap.left, btnPrevious, btnNext);
        if (panelMap.right != null) {
            absolute_layout_1.AbsoluteLayout.setLeft(panelMap.right.panel, pageWidth);
            panelMap.right.panel.width = 0;
        }
    };
    return SlideUtilities;
}());
exports.SlideUtilities = SlideUtilities;
//# sourceMappingURL=utilities.js.map